# cache2k 1.5.1.Alpha "Gulf of Thailand"

This is a preview release for evaluation purposes and should not be used in production.
The final release is planed as *"Gulf of Thailand **1.6.0.Final**"*.

## New and Noteworthy

- New timer based on hierarchical timer wheels, which is more performance and
  scales linear with more cache entries
- No more extra thread per cache, in cache timer is used, e.g. for expiry

## Possible Breakages

- No separate executor for async listeners by default any more.
  If an async listener executor is not specified it uses the executor
  defined by `Cache2kBuilder.executor` which in turn defaults to the 
  common `ForkJoinPool` in Java 8.
- Slightly more lag for operations triggered by time, e.g. cache
  cleanup after expiry, calls of expiry listeners, refreshing.
  The lag can be controlled by `Cache2kBuilder.timerLag`
  
## API Changes 

- Deprecated `ExpiryTimeValues.NO_CACHE`
- Deprecated `Cache2kBuilder.prefetchExecutor`, introduced `Cache2kBuilder.refreshExecutor` (rename) 

## Fixes and Improvements

- Remove hash quality metric
- `MutableCacheEntry.reload()` does load the entry even if already cached

